unit UfrmMain;

{ $Revision: $ }
{  $Archive: $ }
{ $Workfile: $ }
{   $Author: $ }
{     $Date: $ }
{  $Modtime: $ }
{  $History: $ }
{  $NoKeywords: $ }

interface

uses
	Windows,
	Classes,
	Graphics,
	Forms,
	Controls,
	Menus,
	Dialogs,
	StdCtrls,
	Buttons,
	ExtCtrls,
	SysUtils,
	Stoptime;

type
	TPaintThread	= class(TThread)
	protected
		procedure Execute; override;
	public
		Line			: Integer;
		Bitmap		: TBitmap;
		ColorMask	: DWORD;
		Control		: TControl;

		procedure Paint;
	end;

	TfrmMain = class(TForm)
		pnlToolbar	: TPanel;
		pnlExit			: TPanel;
		btnExit			: TSpeedButton;
    StopTimer1: TStopTimer;
    Image1			: TImage;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    StopTimer2: TStopTimer;
    StopTimer3: TStopTimer;
		procedure FormCreate(Sender: TObject);
		procedure ShowHint(Sender: TObject);
		procedure cmdExit(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ThreadTermination(Sender: TObject);
    procedure StopTimer1TimeAsString(Hour, Min, Sec, MSec: Cardinal;
      var TimeString: string);
	private
		{ Private declarations }
		FPaintThread	: TPaintThread;
	public
		{ Public declarations }
	end;

var
	frmMain: TfrmMain;

implementation

{$R VERSIONINFO.RES}
{$R *.DFM}

// ----------------------------------
// TPaintThread
// ----------------------------------

procedure TPaintThread.Execute;
var
	y			: Integer;
begin
	if Terminated or (Bitmap = nil) then begin
		Exit;
	end;

	for y := 0 to Bitmap.Height - 1 do begin
		Line	:= y;
		Synchronize(Paint);
	end;
end;

procedure TPaintThread.Paint;
var
	x			: Integer;
begin
	for x := 0 to Bitmap.Width - 1 do begin
		Bitmap.Canvas.Pixels[x, Line]	:= Bitmap.Canvas.Pixels[x, Line] and ColorMask;
	end;
	TSpeedButton(Control).Caption	:= IntToStr(Line);

	Application.ProcessMessages;
end;

// ----------------------------------
// TfrmMain
// ----------------------------------

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	Application.OnHint := ShowHint;
end;

procedure TfrmMain.ShowHint(Sender: TObject);
begin
	//;
end;

procedure TfrmMain.cmdExit(Sender: TObject);
begin
	Application.MainForm.Close;
end;

procedure TfrmMain.SpeedButton1Click(Sender: TObject);
var
	paintThread	: TPaintThread;
begin
	TControl(Sender).Enabled	:= False;
	
	paintThread							:= TPaintThread.Create(True);
	paintThread.Bitmap			:= Image1.Picture.Bitmap;
	paintThread.ColorMask		:= TControl(Sender).Tag;
	paintThread.Control			:= TControl(Sender);
	paintThread.OnTerminate	:= ThreadTermination;

	case paintThread.ColorMask of
		$FFFF00	: StopTimer1.Start;
		$FF00FF	: StopTimer2.Start;
		$00FFFF	: StopTimer3.Start;
	end;

	paintThread.Resume;
end;

procedure TfrmMain.ThreadTermination(Sender: TObject);
begin
	if Sender is TPaintThread then with TPaintThread(Sender) do begin
		case ColorMask of
			$FFFF00	: begin
					StopTimer1.Stop;
					StopTimer1.Iterations	:= Bitmap.Height;
					StopTimer1.Show;
				end;
			$FF00FF	: begin
					StopTimer2.Stop;;
					StopTimer2.Iterations	:= Bitmap.Height;
					StopTimer2.Show;
				end;
			$00FFFF	: begin
					StopTimer3.Stop;;
					StopTimer3.Iterations	:= Bitmap.Height;
					StopTimer3.Show;
				end;
		end;
	end;
end;

procedure TfrmMain.StopTimer1TimeAsString(Hour, Min, Sec, MSec: Cardinal;
	var TimeString: string);
begin
	TimeString	:= 'Dauer : ' + TimeString + ' s';
end;

end.

